
//
//
// Lattice ICE FGA programmer - By bingo@eevblog - 2017
// Based on work from Grant Jennings here: http://gnarlygrey.atspace.cc/development-platform.html#upduino
//
// This is an ugly kludge that i thew together, w. a lot of copy/paste from earlier programs.
// It should be consideres Alpha code , but it works.
//
// Call with : fprog <Binary-filename> 
//
//
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <string.h>
#include <ctype.h>		/* isspace() */
#include <libgen.h>		/* basename() */

#include "defs.h"		//Func prototypes

//#include <bcm2835.h>

#define PGM_VERSION     "1.02"
#define MIN_ARGS        1	// infile




#define CR              0x0d
#define LF              0x0a

#define MAX_BUF_LEN    1024
#define MAX_LEN         255

#define MIN_ARGS        1	// infile


//****************************************************************************************************
// Global Var declarations
//****************************************************************************************************

char *pgmname, *infilename, *outfilename;
char *src_ptr, *dst_ptr, *ch_ptr;
FILE *infile, *outfile;
int i, j, len;

char infile_buf[MAX_BUF_LEN];
char basefilename[MAX_BUF_LEN];
char buf1[MAX_BUF_LEN + 2];
char buf2[MAX_BUF_LEN + 2];
char buf3[MAX_BUF_LEN + 2];
char buf4[MAX_BUF_LEN + 2];


#if 0
int
cfg (FILE * infile)
{
  FILE *fp;
  int filesize = 0, progsize = 0, i;
  char *ptr;
  ssize_t bytes_read = 0;



  fp = infile;

  fseek (fp, 0L, SEEK_END);	//Seek to end , to get size
  filesize = ftell (fp);
  printf ("Filesize = %d\n", filesize);

  fseek (fp, 0L, SEEK_SET);	// Seek to beginning for reading.


  do
    {
      bytes_read = fread (buf1, 1, MAX_BUF_LEN, fp);
      printf ("Bytes read = %d\n", bytes_read);
      progsize += bytes_read;
      if (bytes_read != 0)
	{
	  //prog
	}

    }
  while (bytes_read != 0);

  printf ("Read %d bytes , programmed %d bytes \n", filesize, progsize);

  return 0;
}
#endif


int
close_file (FILE * filehandle)
{

  int ret;

  if (filehandle != NULL)
    ret = fclose (filehandle);

  return (0);
}


void
my_exit (int code)
{
  close_file (infile);

  exit (code);
}


int
open_file (char *filename, FILE ** filehandle, char *fileaccess)
{
  *filehandle = fopen (filename, fileaccess);

  if (*filehandle == NULL)
    {
      fprintf (stderr, "Unable to open file %s\n", filename);
      my_exit (4);
    }


  return (0);
}

char *
locate_char (char *string, char ch)
{
  char *ptr;

  for (ptr = string; *ptr; ptr++)
    {
      if (*ptr == ch)
	return (ptr);
    }

  return ((char *) NULL);
}

void
userhelp (void)
{
  fprintf (stderr, "\n%s Ver: %s - By bingo@eevblog - 2017\n\n", pgmname,
	   PGM_VERSION);
  fprintf (stderr, "Usage: %s <infile> \n", pgmname);
  fprintf (stderr,
	   "<infile>             filename of binary FPGA file to program\n");

}




int
main (int argc, char **argv)
{


  int argument_error = 0;
  char ch;
  char *NullString = "";

  pgmname = NullString;
  infilename = NullString;




  pgmname = argv[0];
  fprintf (stderr, "\n%s version %s\n", pgmname, PGM_VERSION);

  //fprintf(stderr,"argc %d\n",argc);

  if (argc < MIN_ARGS)
    {
      fprintf (stderr, "\nError: Not enough arguments\n");
      userhelp ();
      return 1;
    }


// Strange getopt works on my Linux mint but not on the RPI, well this is a quick hack, dump getopt
#if 0
//
// http://www.gnu.org/software/libc/manual/html_node/Using-Getopt.html
// Note : a ':' after the option char indicates that the optins requires an argument , a '::' indicates the arg is optional.
//

  opterr = 1;			// IF Zero disable getopt builtin err mesgs.
  while ((ch = getopt (argc, argv, "i:")) != -1)
    {
      switch (ch)
	{

	case 'i':
	  /* Set input filename */
	  infilename = optarg;

	  //
	  // Set hostname in struct, from passed infilename
	  //
	  // Strip leading directory info via basename, mostly on linux
	  src_ptr = basename (optarg);
	  //printf("File Basename = %s",src_ptr);
	  if ((ch_ptr = locate_char (src_ptr, '.')) != (char *) NULL)
	    {
	      len = ch_ptr - src_ptr;
	      strncpy (basefilename, src_ptr, len);
	      basefilename[len] = '\0';	// Terminate the hostname string , starts at zero
	      //printf("host=%s - filename len = %d\n",host_data.hostname,len);
	    }
	  break;

	case '?':
	  /* Show help & exit */
	  argument_error = 1;
	  userhelp ();
	  return 1;
	  break;
	default:
	  fprintf (stderr, "Unknown option: %c , hex %02x\n", ch, ch);
	  argument_error = 1;
	  userhelp ();
	  return 1;
	}
    }

#endif

#if 1
  strcpy (infile_buf, argv[argc - 1]);
  infilename = infile_buf;
  printf ("infile = %s, %s\n", infile_buf, infilename);
#endif

  if ((strlen (infilename) == 0))
    {
      fprintf (stderr, "\nError:  FPGA binfile name option is required \n");
      userhelp ();
      return 1;
    }
  else
    {

      open_file (infilename, &infile, "rb");
    }

  if (infile == 0)
    {
      fprintf (stderr, "\nError: Unable to open infile %s \n", infilename);
      return 5;
    }

//bcm2835_set_debug(1);
  if (!bcm2835_init ())
    return 1;

  cfg (infile);


  close_file (infile);

  return 0;

}
